<!DOCTYPE html>
<html lang="en">
    <head>
        <meta charset="UTF-8">
        <meta http-equiv="X-UA-Compatible" content="IE=edge">
        <meta name="viewport" content="width=device-width, initial-scale=1.0">
        <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
        <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.4/css/all.min.css">
        <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
        <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    
        <!-- Import Datatable sau jquery -->
        <!-- Import them style bootstrap cho datatable -->
        <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
        <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
        <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
    
        <title>Task41.55</title>
    </head>
    <body>
        <div class="container-fluid">
            <h3 class="text-center">DANH SÁCH ĐƠN HÀNG
            </h3>
            <div class="container jumbotron">
                <div class="row form-group">
                    <div class="col-md-2">
                        <label for="">Trang thái order</label>
                    </div>
                    <div class="col-md-3">
                        <select class="form-control" name="" id="select-order-status">
                            <option value="0">(all)</option>
                            <option value="open">open</option>
                            <option value="confirmed">confirmed</option>
                            <option value="cancel">cancel</option>
                        </select>
                    </div>
                    <div class="col-md-2">
                        <label for="">Loại pizza</label>
                    </div>
                    <div class="col-md-3">
                        <select class="form-control" name="" id="select-pizza-type">
                            <option value="0">(all)</option>
                            <option value="hawaii">hawaii</option>
                            <option value="bacon">bacon</option>
                            <option value="seafood">seafood</option>
                        </select>
                    </div>
                    <div class="col-md-2">
                        <button class="btn btn-primary form-control" id="btn-fiter-orders"><i class="fas fa-search"></i>&nbsp; Lọc</button>
                    </div>
                </div>
            </div>
            <table class="table table-bordered table-striped table-hover" id="order-users-table">
                <thead class="bg-primary text-light">
                    <tr>
                        <th>Order ID</th>
                        <th>Kich co combo</th>
                        <th>Loại pizza</th>
                        <th>Nước uống</th>
                        <th>Thành tiển</th>
                        <th>Họ và tên</th>
                        <th>Số điện thoại</th>
                        <th>Trạng thái</th>
                        <th>Chi tiết</th>
                    </tr>
                </thead>
            </table>
        </div>
    </body>
    <script>
        "use strict";
        /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
        const gBASE_URL = "http://203.171.20.210:8080/devcamp-pizza365/orders";
        var gOrderData={
            orders:[],
            filterOrder:function(paramFilterObj){
                //console.log(paramFilterObj)
                var vResult = [];
                //Lọc dữ liệu trên mảng order
                vResult = this.orders.filter(function(order){
                    return(
                        //Lọc mảng trang thải
                        ((paramFilterObj.trangThai === "0")||(order.trangThai!=null &&(order.trangThai.toLowerCase().includes(paramFilterObj.trangThai.toLowerCase())))) &&
                        //Lọc mảng pizza
                        ((paramFilterObj.loaiPizza === "0")||(order.loaiPizza!=null && (order.loaiPizza.toLowerCase().includes(paramFilterObj.loaiPizza.toLowerCase()))))
                    )
                })
                return vResult;
            }
            
        }
        const gCOLUMN_DATA = ["orderCode","kichCo","loaiPizza","idLoaiNuocUong","thanhTien","hoTen","soDienThoai","trangThai","chitiet"]
        const gORDER_ID_COL = 0;
        const gKICH_CO_COL = 1;
        const gLOAI_PIZZA_COL = 2;
        const gLOAI_NUOC_UONG_COL = 3;
        const gTHANH_TIEN_COL = 4;
        const gHO_TEN_COL = 5;
        const gSO_DIEN_THOAI_COL = 6;
        const gTRANG_THAI_COL = 7;
        const gACTION_COL = 8;
        var gTable = $("#order-users-table").DataTable({
            columns:[
                {data:gCOLUMN_DATA[gORDER_ID_COL] },
                {data:gCOLUMN_DATA[gKICH_CO_COL] },
                {data:gCOLUMN_DATA[gLOAI_PIZZA_COL] },
                {data:gCOLUMN_DATA[gLOAI_NUOC_UONG_COL] },
                {data:gCOLUMN_DATA[gTHANH_TIEN_COL] },
                {data:gCOLUMN_DATA[gHO_TEN_COL] },
                {data:gCOLUMN_DATA[gSO_DIEN_THOAI_COL] },
                {data:gCOLUMN_DATA[gTRANG_THAI_COL] },
                {data:gCOLUMN_DATA[gACTION_COL] },
            ],
            columnDefs:[
                {
                    targets:gACTION_COL,
                    render:function(data,type,row,meta){
                        return `<button id="btn-detail" class="btn btn-primary"><i class="fas fa-info"></i>&nbsp;Chi tiết</button>`
                    }
                }
            ]
        })
        /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
        //Thêm event handler cho nút chi tiết
        $("#order-users-table").on("click","#btn-detail",onBtnDetailClick);
         //Thêm event handler cho nút lọc
         $("#btn-fiter-orders").on("click",onBtnFilterOrderClick)
        /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */  
        $(document).ready(function(){
            "use strict";
            callAjaxGetDataOrder();
        })
        //Hàm sữ lý sự kiện cho nút chi tiết
        function onBtnDetailClick(){
            "use strict"
            //Xác định thẻ tr là cha của nút được chọn
            var vRowSelected = $(this).parents('tr');
            //Lấy datatable row
            var vDatatableRow = gTable.row(vRowSelected); 
            //Lấy data của dòng 
            var vUserData = vDatatableRow.data();
            console.log(vUserData)
        }
        //Hàm xữ lý sự kiện cho nút lọc
        function onBtnFilterOrderClick(){
            "use strict";
            //B1:Khai báo biến và thu thập dữ liệu
            var vFlilterObj = {
                trangThai:"",
                loaiPizza:""
            }
            getFilterData(vFlilterObj);
            //console.log(vFlilterObj);
            //B2:Kiểm tra dữ liệu(bỏ qua)

            // B3: Lọc dữ liệu và hiển thị kết quả
            var vFilterOrder = gOrderData.filterOrder(vFlilterObj)
            //console.log(vFilterOrder);
            loadDataToTable(vFilterOrder);
        }
        /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
        //Hàm thu thập dữ liệu
        function getFilterData(paramData){
            "use strict";
            paramData.trangThai = $("#select-order-status").val();
            paramData.loaiPizza = $("#select-pizza-type").val();
        }
        //Hàm đổ dữ liệu vào table
        function loadDataToTable(paramData){
            "use strict";
             //Xóa toàn bộ dữ liệu đang có của bảng
            gTable.clear();
             //Cập nhật data cho bảng 
            gTable.rows.add(paramData);
            //Cập nhật lại giao diện hiển thị bảng
            gTable.draw();
        }
        //Hàm hiển thị ra console
        function displayInconsole(paramData){
            "use strict";
            console.log(paramData);
        }
        //Hàm lấy thông tin order từ api
        function callAjaxGetDataOrder(){
            "use strict";
            $.ajax({
                url:gBASE_URL,
                type:"GET",
                dataType:"json",
                success:function(responseObject){
                    gOrderData.orders = responseObject;
                    //Hiển thị ra console
                    displayInconsole(gOrderData.orders);
                    //Hiển thị dữ liệu order vào talbe
                    loadDataToTable(gOrderData.orders);
                },
                error:function(ajaxContext){
                    alert(ajaxContext.responseText);
                }
            })
        }
    </script>
</html>